Subject: Re: [RFC] ice: Reconfigure tx scheduling for SR-IOV

From: Jakub Kicinski <[email-masked]>
Date: Wed, 6 Jul 2022 12:56:16 -0700

Reminder: please don't top post on the Linux lists.

On Wed, 6 Jul 2022 12:54:12 +0200 Wilczynski, Michal wrote:
> Hi,
> 
> Thank you for your e-mail.
> 
> I considered using devlink-rate, and it seems like a good fit. However 
> we would also
> 
> need support for rate-limiting for individual queues on the VF. 
> Currently we have
> 
> two types of rate objects in devlink-rate: leaf and node. Would adding a 
> third one - queue be accepted ?

Something along those lines. IIUC htb offload as admission control for
VF representors is not a thing today, so since devlink rate exists the
lowest amount of duplication would be teaching it about queues.

> Also we might want to add some other object rate parameters to currently 
> existing ones, for example 'priority'.

Presumably you can't admission control at a granularity higher than 
a queue, so grouping queues should cover all use cases.

> If this sounds acceptable I will work on the patch and submit it as 
> soon, as it's ready.

I'd be curious to hear from nVidia and Corigine folks as well.

We can revive the switchdev call if talking over VC helps with
the alignment between vendors.